/* $Id: eeprom.c,v 1.3 1996/03/26 22:47:13 james Exp $ */
/*
 * $Log: eeprom.c,v $
 * Revision 1.3  1996/03/26 22:47:13  james
 * Put the function return types on the line before the function's name.
 *
 * Revision 1.2  1995/03/31 05:51:30  james
 * Added read_eeprom_block(), write_eeprom_block(), and write_eeprom().
 *
 * Revision 1.1  1995/03/30  20:26:00  james
 * Initial revision
 *
 */

#include <assert.h>
#include "jy_sg.h"

#define ASSERT(x) assert(x)

BYTE
read_eeprom(BYTE ee_loc)
{
  ASSERT(ee_loc < MAX_SG_EEPROM_SIZE );
  write_dsp(EEPROM_READ_COMMAND);
  write_dsp(EEPROM_READ_SUBCOMMAND);
  write_dsp(ee_loc);
  return read_dsp();
}

void
write_eeprom(BYTE ee_loc, BYTE val)
{
  ASSERT(ee_loc < MAX_SG_EEPROM_SIZE);
  write_dsp(EEPROM_WRITE_COMMAND);
  write_dsp(EEPROM_WRITE_SUBCOMMAND);
  write_dsp(ee_loc);
  write_dsp(val);
}

void
read_eeprom_block(BYTE* data, BYTE n)
{
  BYTE eeprom_location;
  
  for(eeprom_location=0; eeprom_location < n; eeprom_location++)
    data[eeprom_location] = read_eeprom(eeprom_location);
}

void
write_eeprom_block(BYTE* data, BYTE n)
{
  BYTE eeprom_location;
  
  for(eeprom_location=0; eeprom_location < n; eeprom_location++)
    write_eeprom(eeprom_location, data[eeprom_location]);
}

/*
 * To read from the EEPROM:-
 * Send DSP command 08
 * Send DSP sub-command 07.
 * Send the EEPROM location, EE_LOC.
 * Read from the DSP the EEPROM value at location EE_LOC.
 */

/*
 * To write to the EEPROM:-
 * Send DSP command 08
 * Send DSP sub-command 08.
 * Send the EEPROM location, EE_LOC.
 * Send the EEPROM data to be written.
 */

